package com.matejdro.bukkit.jail;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Chest;
import org.bukkit.block.Sign;

public class JailCell {
	String jailname;
	String player;
	Location teleport;
	Location sign;
	Location chest;
	Location chest2;
	
	public JailCell(String JailName, String Player)
	{
		jailname = JailName;
		player = Player;
	}
	
	public JailZone getJail()
	{
		return Jail.zones.get(jailname);
	}
	
	public Location getTeleport()
	{
		return teleport;
	}
	
	public void setTeleport(Location input)
	{
		teleport = input;
	}
	
	public void setTeleport(String input)
	{
		if (input == null || input.trim().equals("")) return;
		String[] str = input.split(",");
		Location loc = new Location(getJail().getTeleportLocation().getWorld(), Double.parseDouble(str[0]), Double.parseDouble(str[1]),Double.parseDouble(str[2]));
		teleport = loc;
	}
		
	public Chest getChest()
	{
		if (chest == null || chest.getBlock() == null || chest.getBlock().getType() != Material.CHEST) return null;

		return (Chest) chest.getBlock().getState();
	}
	
	public void setChest(Location input)
	{
		chest = input;
	}

	
	public void setChest(String input)
	{
		if (input == null || input.trim().equals("")) return;
		String[] str = input.split(",");
		Location loc = new Location(getJail().getTeleportLocation().getWorld(), Double.parseDouble(str[0]), Double.parseDouble(str[1]),Double.parseDouble(str[2]));
		chest = loc;
	}
	
	public Chest getSecondChest()
	{
		if (chest2 == null || chest2.getBlock() == null || chest2.getBlock().getType() != Material.CHEST) return null;

		return (Chest) chest2.getBlock().getState();
	}

	
	public void setSecondChest(Location input)
	{
		chest2 = input;
	}

	
	public void setSecondChest(String input)
	{
		if (input == null || input.trim().equals("")) return;
		String[] str = input.split(",");
		Location loc = new Location(getJail().getTeleportLocation().getWorld(), Double.parseDouble(str[0]), Double.parseDouble(str[1]),Double.parseDouble(str[2]));
		chest2 = loc;
	}
	
	public Sign getSign()
	{
		if (sign == null || sign.getBlock() == null || (sign.getBlock().getType() != Material.SIGN_POST && sign.getBlock().getType() != Material.WALL_SIGN)) return null;
		return (Sign) sign.getBlock().getState();
	}
	
	public void setSign(Location input)
	{
		sign = input;
	}

	
	public void setSign(String input)
	{
		if (input == null || input.trim().equals("")) return;
		String[] str = input.split(",");
		Location loc = new Location(getJail().getTeleportLocation().getWorld(), Double.parseDouble(str[0]), Double.parseDouble(str[1]),Double.parseDouble(str[2]));
		sign = loc;
	}
	
	public String getPlayerName()
	{
		return player;
	}
	
	public void setPlayerName(String input)
	{
		player = input;
	}

	
	
}
