package com.matejdro.bukkit.jail;

import java.util.List;

import org.bukkit.block.Block;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerListener;

public class JailPlayer extends PlayerListener {
	private Jail plugin;

	public JailPlayer(Jail instance)
	{
		plugin = instance;
	}		
	
	public void onPlayerInteract(PlayerInteractEvent event) {
		if (event.getAction() == Action.RIGHT_CLICK_BLOCK)
		{
			if ( JailZoneCreation.players.containsKey(event.getPlayer().getName()) && event.getPlayer().getItemInHand().getTypeId() == Settings.SelectionTool)
			{
				JailZoneCreation.select(event.getPlayer(), event.getClickedBlock());
				event.setCancelled(true);
			}
			else if ( JailCellCreation.players.containsKey(event.getPlayer().getName()) && event.getPlayer().getItemInHand().getTypeId() == Settings.SelectionTool)
			{
				JailCellCreation.select(event.getPlayer(), event.getClickedBlock());
				event.setCancelled(true);
			}
		}
		else if (Settings.EnableJailStick && (event.getAction() == Action.LEFT_CLICK_AIR || event.getAction() == Action.LEFT_CLICK_BLOCK))
		{
			Player player = event.getPlayer();
			if (player.getItemInHand().getTypeId() != Settings.JailStickId) return;
			if (!plugin.permission(player, "jail.usejailstick", player.isOp())) return;
			
			List<Block> targets = player.getLineOfSight(null, Settings.JailStickRange);
			targets.remove(0);
			for (Block b : targets)
			{
				for (Player p : plugin.getServer().getOnlinePlayers())
				{
					if ((b == p.getLocation().getBlock() || b == p.getEyeLocation().getBlock()) && plugin.permission(player, "jail.canbestickjailed", true))
					{
						String args[] = new String[2];
						args[0] = p.getName();
						args[1] = String.valueOf(Settings.JailStickTime);
						plugin.PrepareJail((CommandSender) event.getPlayer(), args); 
					}
				}
			}
		}
	}

	
	 public void onPlayerJoin(PlayerJoinEvent event) {
		 if (Jail.prisoners.containsKey(event.getPlayer().getName().toLowerCase()))
		 {
			 JailPrisoner prisoner = Jail.prisoners.get(event.getPlayer().getName().toLowerCase());
			 if (prisoner.OfflinePending())
			 {
				 if (prisoner.getTransferDestination().isEmpty())
				 {
					 if (prisoner.getRemainingTime() != 0)
					 {
						 plugin.Jail(prisoner, event.getPlayer());
					 }
					 else
					 {
						 plugin.UnJail(prisoner, event.getPlayer());
					 } 
				 }
				 else
				 {
					 plugin.Transfer(prisoner, event.getPlayer());
				 }
				 
			 }
		 }
	 }
	 
	
}
